<template>
    <v-row no-gutters class="repository">
        <v-col
            md="10"
            offset-md="1"
            sm="12"
            offset-sm="0">
            <h1>Welcome to my repository</h1>
            <v-card
                class="record text-left"
                outlined
                v-for="(record, hash) in records"
                :key="hash">
                <v-list-item three-line>
                    <v-list-item-content>
                        <v-card-title class="title">{{ record.title }}</v-card-title>
                        <v-card-subtitle class="hash">{{ hash }}</v-card-subtitle>
                        <v-card-text>{{ record.author }}</v-card-text>
                        <v-card-actions>
                            <v-btn @click="announce(hash)" text>Announce</v-btn>
                            <v-btn @click="archive(hash)" text>Archive</v-btn>
                        </v-card-actions>
                    </v-list-item-content>
                    <v-list-item-avatar
                        tile
                        size="200"
                    ><qrcode :value="record.hash" :options="{ width: 200 }"></qrcode></v-list-item-avatar>
                </v-list-item>
            </v-card>
        </v-col>
    </v-row>
</template>

<script>
import Vue from 'vue'
import VueQrcode from '@chenfengyuan/vue-qrcode'
import OrbitDB from 'orbit-db'
import Archive from '../../build/contracts/Archive.json'
import IPFS from 'ipfs'

Vue.component(VueQrcode.name, VueQrcode);

export default {
    name: 'repository',
    props: ['state'],
    data: function () {
        return {
            records: {}
        }
    },
    computed: {
        stateLoaded() {
            return this.state.ipfs && this.state.owner
        }
    },
    watch: {
        stateLoaded() {
            this.loadRecords()
        }
    },
    methods: {
        loadRecords: async function () {
            if (this.state.owner && this.state.ipfs) {
                const orbitdb = await OrbitDB.createInstance(this.state.ipfs)
                const archiveDb = await orbitdb.log(this.state.owner+'.archive')
                await archiveDb.load()

                let records = {}

                for (let record of archiveDb.iterator({ limit: -1 })) {
                    var hash = record.payload.value
                    var metadataDbName = hash + '.metadata'
                    var metadataDb = await orbitdb.keyvalue(metadataDbName)

                    await metadataDb.load()

                    records[hash] = metadataDb.all
                    metadataDb.close()
                }

                this.records = records
            }
        },
        async archive(hash) {
            const web3 = window.web3
            const networkId = await web3.eth.net.getId()
            const network = Archive.networks[networkId]

            if (network) {
                const abi = Archive.abi
                const address = network.address
                const contract = new web3.eth.Contract(abi, address)

                try {
                    await contract.methods.save(hash).send({from: this.owner})
                } catch (e) {
                    console.log(e)
                }

                const result = await contract.methods.get().call()

                this.state.ipfs.hash = result
            } else {
                console.log('Contract not found. Try another network.')
            }
        },
        async announce(hash) {
            const topic = 'QmacFWNvpsq5wEnL199Zxzp86LB9MFYmEDzrhb89LaZkxW'
            const msg = IPFS.Buffer.from(hash)

            await this.state.ipfs.pubsub.publish(topic, msg)
        }
    },
    mounted: function () {
        this.loadRecords()
    }
}
</script>
